
--[[
Shards Server version: 0.3.4
Author: Nathaniel Staples
Date Modified: 29/08/2016

This file containes the functions to rotate objects placed on the map
Code exmaples taken from house_control.lua

Function list:
/rotateCW -- rotate an object 5 degrees clockwise
/rotateACW -- rotate an object 5 degrees anti-clockwise

DefaultCommandFuncs -- adds the fuctions for the commands to the God commands list
RegisterCommand -- registers the commands for the command line.

--]]

----------------------------------------
-- Variables
----------------------------------------
local CWrotation = 5
local ACWrotation = -5

----------------------------------------
--Functions
----------------------------------------

-- Rotates selected object clockwise
RegisterEventHandler(EventType.ClientTargetGameObjResponse, "rotateCW", 
	function(targetObject, player)
		local commandInfo = GetCommandInfo("rotateCW")

		if not(this:HasAccessLevel(commandInfo.AccessLevel)) then return end	
		
		if(targetObject == nil) then
			player:SystemMessage("Select a valid object.")
			return
		end
		local newRot = targetObject:GetRotation() + (Loc(0,CWrotation,0))
		targetObject:SetRotation(newRot)
		this:RequestClientTargetGameObj(this, "rotateCW")
	end)

-- Rotates selected object Anti-clockwise
RegisterEventHandler(EventType.ClientTargetGameObjResponse, "rotateACW", 
	function(targetObject, player)
		local commandInfo = GetCommandInfo("rotateACW")

		if not(this:HasAccessLevel(commandInfo.AccessLevel)) then return end	

		if(targetObject == nil) then
			player:SystemMessage("Select a valid object.")
			return
		end

		local newRot = targetObject:GetRotation() + (Loc(0,ACWrotation ,0))
		targetObject:SetRotation(newRot)
		this:RequestClientTargetGameObj(this, "rotateACW")
	end)



-- Adds the command functions to the script table
DefaultCommandFuncs= {
	rotateCW = function()		
		this:RequestClientTargetGameObj(this, "rotateCW")
	end,
	
	rotateACW = function()		
		this:RequestClientTargetGameObj(this, "rotateACW")
	end
}

--Allow the command to be used in game by typing it in the text area
RegisterCommand{Command="rotateCW", Category = "God Power", AccessLevel = AccessLevel.DemiGod, Func=DefaultCommandFuncs.rotateCW, Usage="Select a valid object", Desc="Rotates a static object Clockwise." }
RegisterCommand{Command="rotateACW", Category = "God Power", AccessLevel = AccessLevel.DemiGod, Func=DefaultCommandFuncs.rotateACW, Usage="Select a valid object", Desc="Rotates a static object Anti-Clockwise." }
