-- AI module global object extensions

GameObj.Meta.HasModularAI = function(target)
	if target:HasModule("ai_modular") then
		return true
	end
end

GameObj.Meta.HasAIModule = function (target, mod)
	if not target:HasModularAI() then return false end

	local modules = target:GetObjVar("AIModules")
	if modules ~= nil then
		return modules[mod] ~= nil
	end
end

GameObj.Meta.GetAIModules = function (target)
	if not target:HasModularAI() then return {} end
	return target:GetObjVar("AIModules")
end

GameObj.Meta.AddAIModule = function (target, mod)
	target:SendMessage("AddAIModule", mod)
end

GameObj.Meta.DelAIModule = function (target, mod)
	target:SendMessage("DelAIModule", mod)
end