-- Visual effects window

ac_commands.UI_EffectWindow = function(user)
	local path = "Build\\Base\\EffectReference.txt"
	--local f = io.open(path, "r")
	local effectlist = {}
	for line in io.lines(path) do
		effectlist[#effectlist+1] = line
	end

	local columns=6
	local ColWidth=220
	local RowHeight=25
	local x= 20
	local y= 10
	--Define the window 
	local newWindow = DynamicWindow("EffectWindow","Play an effect at me",columns*ColWidth+60,900)

	table.sort(effectlist)
	for i,effect in ipairs(effectlist) do
		local w= (i-1)%columns
		local h= math.floor((i-1)/columns)
		--DebugMessage(tostring(i)..":"..sound.."x:"..tostring(w).." y:"..tostring(h) )
		newWindow:AddButton(	x+w*ColWidth  , 
								y+h*RowHeight , 
								string.gsub(effect, " ", "_"),  
								effect, 
								ColWidth, 
								RowHeight, 
								"Play the effect "..effect,
								"",
								false)

	end

	this:OpenDynamicWindow(newWindow)
end

RegisterCommand{ Command="effectwindow", AccessLevel = AccessLevel.Immortal, Func=ac_commands.UI_EffectWindow, Desc="A window with a list of playable effects"}


---Handle the playound responses
RegisterEventHandler(EventType.DynamicWindowResponse, "EffectWindow",
  function (user,buttonId)
  	this:PlayEffect(buttonId, 8)
  end)