-- General effect utilies (bensku)

require "incl_effect_presets"

-- Initalize effect script in given object
function InitEffects(gameObj)
	if gameObj.HasModule == nil then return end
	--DebugMessage("GameObj is "..tostring(gameObj))
	--LuaDebugCallStack()

	if not gameObj:HasModule("status_effect") then -- TODO Don't poison rocks
		--gameObj:SystemMessage("Adding status_effect to YOU!")
		gameObj:AddModule("status_effect")
	end
end

function InflictFromPackedData(gameObj, data, force)
	if data == nil then return end
	local force = force or false
	for number,effect in ipairs(data) do
		gameObj:SendMessage("InflictEffect", effect, false)
	end
end

-- Get's cure process with given parameters (for simple cases)
function GetCureProcess(effectTypes, numCures)
	--DebugMessage("Get cure process")
	if type(effectTypes) == "string" then
		local typeTable = {}
		typeTable[effectTypes] = true
		effectTypes = typeTable
	end
	local effectTypes = effectTypes or true
	local numCures = numCures or -1

	return function(effects) -- Copypaste from here and extend if you need!
		--DebugMessage("Got the effects!")
		local toCure = {}
		for id,effect in pairs(effects) do
			if numCures == 0 then break end
			if effectTypes[effect.abstractType] or effectTypes[effect.specificType] or type(effectTypes) ~= "table" then
				--DebugMessage("Curing it!")
				toCure[id] = true
				if numCures ~= -1 then numCures = numCures - 1 end
			end
		end
		return toCure
	end
end

-- Inflicts an effect to game object (gameObj, effect)
function InflictEffect(gameObj, effect)
	if gameObj.SendMessage == nil then return end

	InitEffects(gameObj)
	effectData = nil
	if type(effect) == "table" then -- Effect was directly provided
		effectData = effect
	else -- effect was preset key
		effectData = GetEffectPreset(effect)
	end
	gameObj:SendMessage("InflictEffect", effectData, false)
	gameObj:SendMessage("WakeUpEffects")
end