require 'base_dye_merchant'



SPEAK_DELAY = 15000			-- 5 second interval between greetings
lastHelloTime = 0
lastGoodbyeTime = 0

AddView("MerchantNearbyPlayer", SearchPlayerInRange(OBJECT_INTERACTION_RANGE))

RegisterEventHandler(EventType.EnterView, "MerchantNearbyPlayer", 
	function(target)
	    --DebugMessage("npc:HandleEnterView(" .. tostring(target) .. ")")

	    -- Only speak if enough time has passed since last greeting
	    if ((lastHelloTime + SPEAK_DELAY) < ServerTimeMs()) then
	    	Speak{Text="Greetings my friends. Bored of your uniformed and boring cloth or armor ? Like some Dyes?"}
	    	Speak{Text="Checkout my Containers and BE AMAZED !."}
	    	this:FaceObject(target)
	    	lastHelloTime = ServerTimeMs()
	    end
	end)

RegisterEventHandler(EventType.LeaveView, "MerchantNearbyPlayer", 
	function(target)
		if ((lastGoodbyeTime + SPEAK_DELAY) < ServerTimeMs()) then
			Speak{Text="Cheers"}
			lastGoodbyeTime = ServerTimeMs()
		end

		-- close their bank window
		local bankObj = target:GetEquippedObject("Bank")
		if( bankObj ~= nil ) then
			bankObj:SendCloseContainer(target)
		end
	end)

-- when user clicks on merchant, show menu
RegisterEventHandler(EventType.ClientObjectCommand, "interact", 
	function(user)
		this:FaceObject(user)
			menuItems = {"Bank"}
			user:RequestContextMenu(this,"merchant_interact", menuItems)	
	end)

-- me
RegisterEventHandler(EventType.ContextMenuResponse,"merchant_interact", 
	function (user,menuIndex)
	    if( menuIndex == 0 ) then return end
	    if( user == nil or not(user:IsValid())) then return end
	    if( user:DistanceFrom(this) > OBJECT_INTERACTION_RANGE) then return end

	    if( menuIndex == 1 ) then
	    	user:OpenBank()
	    end
	end)